;==================================================================
;
;  scnsmctl.asm
;  Copyright (c) 1996-1998, Soundcode, Inc. All rights reserved.
;
;  This code and information is provided "as is" without warranty 
;  of any kind, either expressed or implied, including but not 
;  limited to the implied warranties of merchantability and/or 
;  fitness for a particular purpose. 
;
;  08/15/98 -- Baseline, Jim Adler
;  11/04/98 -- 1.0 Beta Release
;
;==================================================================

   name SCNSM
   .386p

;==================================================================
;  I N C L U D E S
;==================================================================

   include vmm.inc
   include scwraps.inc

;==================================================================
;  V I R T U A L   D E V I C E   D E C L A R A T I O N
;==================================================================

SCNSM_Device_ID   equ 7135H   ; BUGBUG, a dummy ID for now
NSM_MAJOR_VERSION equ 1H
NSM_MINOR_VERSION equ 0H

Declare_Virtual_Device \
   SCNSM, NSM_MAJOR_VERSION, NSM_MINOR_VERSION, SCNSM_Control, \
   SCNSM_Device_ID, Undefined_Init_Order, \
   SCNSM_OnPMApi, SCNSM_OnPMApi

VxD_LOCKED_CODE_SEG

;==================================================================
;  W R A P P E R S
;==================================================================

;==================
; Map_Lin_To_VM_Addr
;==================
linAddr equ [esp + 4]
limit equ [esp + 8]
pSeg equ [esp + 12]
pOffset equ [esp + 16]

StartCDecl Map_Lin_To_VM_Addr@16
	mov	eax, linAddr  
	mov	ecx, limit  
	vmmcall	Map_Lin_To_VM_Addr  
	mov	eax, pSeg  
	mov	[eax], ecx  
	mov	eax, pOffset  
	mov	[eax], edx  
	setnc	al
	and	eax, 1
   ret 16
EndCDecl	Map_Lin_To_VM_Addr@16

;==================
; PageAllocateX
;==================
nPages equ [ebp + 8]
pType equ [ebp + 12]
hVM equ [ebp + 16]
alignMask equ [ebp + 20]
minPhys equ [ebp + 24]
maxPhys equ [ebp + 28]
physAddr equ [ebp + 32]
flags equ [ebp + 36]
hMem equ [ebp + 40]
pMem equ [ebp + 44]

StartCDecl PageAllocateX@40
   push ebp
	mov ebp, esp
   vmmcall _PageAllocate <nPages, pType, hVM, alignMask, minPhys, maxPhys, physAddr, flags>  
   mov ecx, eax  
   or	ecx, edx  
   jz	done     ;; Fail, 0 in eax already  
   mov ecx, hMem
   mov [ecx], eax  
   mov ecx, pMem
   mov [ecx], edx  
   mov eax, 1  ;; Success  
done:	
   pop ebp
   ret 40  
EndCDecl	PageAllocateX@40

;==================
; Test_Sys_VM_Handle
;==================
StartCDecl Test_Sys_VM_Handle@4
   push ebx
   mov ebx, [esp+8]	; Get hvm
   VxDCall Test_Sys_VM_Handle
   sete al
   pop ebx
   movzx eax, al
   ret 4
EndCDecl	Test_Sys_VM_Handle@4

;==================================================================
;
;  PROCEDURE: SCNSM_Control
;
;  DESCRIPTION:
;     Device control procedure for the SCNSM VxD
;
;  ENTRY:
;     EAX = Control call ID
;
;  EXIT:
;     On success, carry clear
;
;==================================================================

BeginProc SCNSM_Control
   Control_Dispatch Init_Complete, _OnInitComplete, cCall, <ebx>
   Control_Dispatch System_Exit, _OnSystemExit, cCall, <ebx>
   Control_Dispatch Sys_Dynamic_Device_Init, _OnSysDynamicDeviceInit, cCall, <ebx>
   Control_Dispatch Sys_Dynamic_Device_Exit, _OnSysDynamicDeviceExit, cCall, <ebx>
   Control_Dispatch W32_DeviceIOControl, _OnW32DeviceIoControl, cCall, <esi>
   clc
   ret
EndProc SCNSM_Control

;==================================================================
;
;  PROCEDURE: SCNSM_OnPMApi
;
;  DESCRIPTION:
;     Protected mode API handler
;
;  ENTRY:
;     EAX = function number
;     EBX = parameter 1
;     ECX = parameter 2 
;     EDX = parameter 3
;
;  EXIT:
;     EAX
;
;==================================================================

BeginProc SCNSM_OnPMApi
   scall   OnPMApi, <[ebp].Client_EAX, [ebp].Client_EBX, [ebp].Client_ECX, [ebp].Client_EDX>
   mov     [ebp].Client_EAX, eax
   ret
EndProc SCNSM_OnPMApi

VxD_LOCKED_CODE_ENDS
   end

