/******************************************************************************

   main.cpp
   Copyright (c) 1996-1998, Soundcode, Inc. All rights reserved.

   This code and information is provided "as is" without warranty 
   of any kind, either expressed or implied, including but not 
   limited to the implied warranties of merchantability and/or 
   fitness for a particular purpose. 

******************************************************************************/

/* Standard Headers */
#include <windows.h>
#include <stdio.h>

/* Public Headers */
#include "scnsm.h"

/* Macros */
#define DEVICE "scnsm.vxd"
#define DRIVER   "SCNSM   "

/* Functions */
static void TestApi32();

/*-----------------*/
int main(int argc, char* argv[])
{
   TestApi32();
   return 0;
}

/*-----------------*/
void TestApi32()
{
   HANDLE hDevice = 0;
   DWORD	dwErr;

   DWORD cbPage = 0;

   DWORD version = 0;
   DWORD cbVersion = 0;

   DWORD nPages = 10;
   DWORD cbBufAllocated = 0;
   BYTE* pBuf = 0;

   hDevice = CreateFile("\\\\.\\"DEVICE, 0, 0, NULL, CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, NULL);
   if( hDevice == INVALID_HANDLE_VALUE )
   {
      dwErr= GetLastError();
      fprintf(stderr, "Cannot load %s, dwErr = %08lx\n", DEVICE, dwErr);
      if( dwErr == ERROR_NOT_SUPPORTED )
         DeleteFile("\\\\.\\"DEVICE);
      exit(1);
   }

   if( !DeviceIoControl(hDevice, NSM_GETVERSION, 0, 0, &version, sizeof(version), &cbVersion, NULL) )
   {
		printf("DeviceIoControl::GETVERSION failed (%d)\n", GetLastError() );
      goto exit;
   }
   printf("%s, version %u.%u\n", DEVICE, HIWORD(version), LOWORD(version));

   if( !DeviceIoControl(hDevice, NSM_GETPAGESIZE, 0, 0, &cbPage, sizeof(cbPage), 0, NULL) )
   {
		printf("DeviceIoControl::GETPAGESIZE failed (%d)\n", GetLastError() );
      goto exit;
   }
   printf("\tpage size = %d\n", cbPage);

   if( !DeviceIoControl(hDevice, NSM_ALLOCPAGE, 0, 0, &pBuf, nPages, 0, NULL) )
   {
		printf("DeviceIoControl::NSM_ALLOCPAGE failed (%d)\n", GetLastError() );
      goto exit;
   }
   memset(pBuf, '=', nPages*cbPage);
   pBuf[20] = 0;
   printf("\t%s\n", pBuf);
   strcpy(pBuf, "Just testing!");
   printf("\t%s\n", pBuf);

   if( !DeviceIoControl(hDevice, NSM_FREEPAGE, pBuf, 0, 0, 0, 0, NULL) )
   {
		printf("DeviceIoControl::NSM_FREEPAGE failed (%d)\n", GetLastError() );
      goto exit;
   }

exit:
   CloseHandle(hDevice);
}