#------------------
#
# scnsm.mak
# Copyright (c) 1998, Soundcode, Inc. All rights reserved.
#
#------------------

#------------------
# Configuration
#------------------
!IF "$(CFG)" == ""
CFG=Debug
!MESSAGE No configuration specified. Defaulting to Debug.
!ENDIF 

!IF "$(CFG)" != "Release" && "$(CFG)" != "Debug"
!MESSAGE Invalid configuration "$(CFG)" specified.
!MESSAGE You can specify a configuration when running NMAKE
!MESSAGE by defining the macro CFG on the command line. For example:
!MESSAGE 
!MESSAGE NMAKE /f "scnsm.mak" CFG="Debug"
!MESSAGE 
!MESSAGE Possible choices for configuration are:
!MESSAGE 
!MESSAGE "Release"
!MESSAGE "Debug"
!MESSAGE 
!ERROR An invalid configuration is specified.
!ENDIF 

#------------------
# Paths
#------------------
!IF "$(MASMPATH)" == ""
MASMPATH = C:\Progra~1\DevStu~1\MASM611\Bin
!MESSAGE No MASM bin directory specified. Defaulting to MASMPATH = $(MASMPATH).
!ENDIF 

!IF "$(DDKROOT)" == ""
DDKROOT = C:\Progra~1\DevStu~1\DDK
!MESSAGE No DDK root directory specified. Defaulting to DDKROOT = $(DDKROOT).
!ENDIF 

#------------------
# Commands
#------------------
CPP = cl.exe
RSC = rc.exe
ML = $(MASMPATH)\ml.exe
LNK = link.exe

#------------------
# Constants
#------------------
NAME = scnsm
SRCDIR = .\Source
INCDIR = .\Include
DEFOBJS = $(SRCDIR)\$(NAME).def

#------------------
# Release Build
#------------------
!IF  "$(CFG)" == "Release"

OUTDIR = .\Bin\Release
INTDIR = .\Obj\Release

CFLAGS = /I$(INCDIR) /I$(DDKROOT)\inc32 /I$(DDKROOT)\inc16 /Zdp /Gs /c /DIS_32 /Zl /DWIN31COMPAT /DDEBLEVEL=0 /DWANTVXDWRAPS=1 -W4 /Fo"$(INTDIR)\\" /Fd"$(INTDIR)\\"
AFLAGS = /I$(INCDIR) /I$(DDKROOT)\inc32 /I$(DDKROOT)\inc16 /DIS_32 /W2 /Zd /c /Cx /DMASM6 /DWIN31COMPAT /DDEBLEVEL=0 /DSEGNUM=1 /Fo"$(INTDIR)\\"
LFLAGS = /libpath:$(DDKROOT)\lib /machine:i386 /debugtype:map /pdb:none \
         /def:$(DEFOBJS) /out:"$(OUTDIR)\$(NAME).vxd" /nodefaultlib /map:"$(INTDIR)\$(NAME).map" /vxd vxdwraps.clb

#------------------
# Debug Build
#------------------
!ELSEIF  "$(CFG)" == "Debug"

OUTDIR = .\Bin\Debug
INTDIR = .\Obj\Debug

CFLAGS = /I$(INCDIR) /I$(DDKROOT)\inc32 /I$(DDKROOT)\inc16 /Zdp /Gs /c /DIS_32 /Zl /DWIN40SERVICES /DWIN31COMPAT /DDEBLEVEL=1 /DDEBUG /DWANTVXDWRAPS=1 -W4 /Fo"$(INTDIR)\\" /Fd"$(INTDIR)\\"
AFLAGS = /I$(INCDIR) /I$(DDKROOT)\inc32 /I$(DDKROOT)\inc16 /DIS_32 /W2 /Zd /c /Cx /DMASM6 /DWIN31COMPAT /DDEBLEVEL=1 /DDEBUG /DSEGNUM=1 /Fo"$(INTDIR)\\"
LFLAGS = /libpath:$(DDKROOT)\lib /machine:i386 /debug /debugtype:map /pdb:none \
         /def:$(DEFOBJS) /out:"$(OUTDIR)\$(NAME).vxd" /nodefaultlib /map:"$(INTDIR)\$(NAME).map" /vxd vxdwraps.clb
!ENDIF 

#------------------
# Builds
#------------------
ALL : "$(OUTDIR)\$(NAME).vxd"

CLEAN :
	-@erase "$(INTDIR)\$(NAME).obj"
	-@erase "$(INTDIR)\$(NAME)ctl.obj"

"$(INTDIR)" :
    if not exist "$(INTDIR)/$(NULL)" mkdir "Obj"
    if not exist "$(INTDIR)/$(NULL)" mkdir "$(INTDIR)"

"$(OUTDIR)" :
    if not exist "$(OUTDIR)/$(NULL)" mkdir "Bin"
    if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"

LOBJS = \
	"$(INTDIR)\$(NAME)ctl.obj" \
	"$(INTDIR)\$(NAME).obj"
	
"$(OUTDIR)\$(NAME).vxd" : "$(OUTDIR)" $(LOBJS) $(DEFOBJS)
   $(LNK) @<<
   $(LFLAGS) $(LOBJS)
<<
   mapsym -s -o "$(INTDIR)\$(NAME).sym" "$(INTDIR)\$(NAME).map"

#------------------
# Targets
#------------------
!IF "$(CFG)" == "Release" || "$(CFG)" == "Debug"

SOURCE = $(SRCDIR)\$(NAME).c
DEP_CPP_MAIN_=
"$(INTDIR)\$(NAME).obj" : $(SOURCE) $(INCDIR)\scnsm.h $(SRCDIR)\scwraps.h $(DEP_CPP_MAIN_) "$(INTDIR)"

SOURCE = $(SRCDIR)\$(NAME)ctl.asm
DEP_CPP_MAIN_=
"$(INTDIR)\$(NAME)ctl.obj" : $(SOURCE) $(SRCDIR)\scwraps.inc $(DEP_CPP_MAIN_) "$(INTDIR)"

!ENDIF 

#------------------
# Rules
#------------------
{$(SRCDIR)}.c{$(INTDIR)}.obj::
   $(CPP) @<<
   $(CFLAGS) $< 
<<

{$(SRCDIR)}.asm{$(INTDIR)}.obj::
   $(ML) @<<
   $(AFLAGS) $< 
<<
